/* ========================================
 *
 * The following firmware was developed by Cypress Semiconductor
 * This work is licensed under a Creative Commons Attribution 3.0 Unported License.
 * 
 * http://creativecommons.org/licenses/by/3.0/deed.en_US
 * 
 * You are free to:
 * -To Share — to copy, distribute and transmit the work 
 * -To Remix — to adapt the work 
 * -To make commercial use of the work
 *
 * ========================================
 */
#include <device.h>

#ifndef __DISPLAY_H__
#define __DISPLAY_H__

#define Lcd_COMMAND		0 
#define Lcd_DATA  		1

#define Lcd_X     		84
#define Lcd_Y     		48

#define ASCII			48
		
void LcdInit(void);

void LcdGotoXY(uint8 x, uint8 y);

void LcdBitmap(const unsigned char my_array[]);

void LcdCharacter(char character);

void LcdString(char *characters);

void LcdClear(void);

void LcdWrite(char data_or_comm, char dat);

void LcdSendData(char val);

void LcdPrintBigNumber(uint8 x);

#endif
//[] END OF FILE
