/*******************************************************************************
* File Name: BT_Receiver_IntClock.h
* Version 2.0
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_BT_Receiver_IntClock_H)
#define CY_CLOCK_BT_Receiver_IntClock_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/

void BT_Receiver_IntClock_Start(void);
void BT_Receiver_IntClock_Stop(void);

void BT_Receiver_IntClock_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 BT_Receiver_IntClock_GetDividerRegister(void);
uint8  BT_Receiver_IntClock_GetFractionalDividerRegister(void);

#define BT_Receiver_IntClock_Enable()                         BT_Receiver_IntClock_Start()
#define BT_Receiver_IntClock_Disable()                        BT_Receiver_IntClock_Stop()
#define BT_Receiver_IntClock_SetDividerRegister(clkDivider, reset)  \
                        BT_Receiver_IntClock_SetFractionalDividerRegister((clkDivider), 0)
#define BT_Receiver_IntClock_SetDivider(clkDivider)           BT_Receiver_IntClock_SetDividerRegister((clkDivider), 1)
#define BT_Receiver_IntClock_SetDividerValue(clkDivider)      BT_Receiver_IntClock_SetDividerRegister((clkDivider) - 1, 1)


/***************************************
*             Registers
***************************************/

#define BT_Receiver_IntClock_DIV_REG    (*(reg32 *)BT_Receiver_IntClock__REGISTER)
#define BT_Receiver_IntClock_ENABLE_REG BT_Receiver_IntClock_DIV_REG

#endif /* !defined(CY_CLOCK_BT_Receiver_IntClock_H) */

/* [] END OF FILE */
