/*******************************************************************************
* File Name: BT_Rx.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_BT_Rx_H)
#define CY_ISR_BT_Rx_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void BT_Rx_Start(void);
void BT_Rx_StartEx(cyisraddress address);
void BT_Rx_Stop(void);

CY_ISR_PROTO(BT_Rx_Interrupt);

void BT_Rx_SetVector(cyisraddress address);
cyisraddress BT_Rx_GetVector(void);

void BT_Rx_SetPriority(uint8 priority);
uint8 BT_Rx_GetPriority(void);

void BT_Rx_Enable(void);
uint8 BT_Rx_GetState(void);
void BT_Rx_Disable(void);

void BT_Rx_SetPending(void);
void BT_Rx_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the BT_Rx ISR. */
#define BT_Rx_INTC_VECTOR            ((reg32 *) BT_Rx__INTC_VECT)

/* Address of the BT_Rx ISR priority. */
#define BT_Rx_INTC_PRIOR             ((reg32 *) BT_Rx__INTC_PRIOR_REG)

/* Priority of the BT_Rx interrupt. */
#define BT_Rx_INTC_PRIOR_NUMBER      BT_Rx__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable BT_Rx interrupt. */
#define BT_Rx_INTC_SET_EN            ((reg32 *) BT_Rx__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the BT_Rx interrupt. */
#define BT_Rx_INTC_CLR_EN            ((reg32 *) BT_Rx__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the BT_Rx interrupt state to pending. */
#define BT_Rx_INTC_SET_PD            ((reg32 *) BT_Rx__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the BT_Rx interrupt. */
#define BT_Rx_INTC_CLR_PD            ((reg32 *) BT_Rx__INTC_CLR_PD_REG)



#endif /* CY_ISR_BT_Rx_H */


/* [] END OF FILE */
