/*******************************************************************************
* File Name: Clock_UART.h
* Version 2.10
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_Clock_UART_H)
#define CY_CLOCK_Clock_UART_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/

void Clock_UART_Start(void);
void Clock_UART_Stop(void);

void Clock_UART_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 Clock_UART_GetDividerRegister(void);
uint8  Clock_UART_GetFractionalDividerRegister(void);

#define Clock_UART_Enable()                         Clock_UART_Start()
#define Clock_UART_Disable()                        Clock_UART_Stop()
#define Clock_UART_SetDividerRegister(clkDivider, reset)  \
                        Clock_UART_SetFractionalDividerRegister((clkDivider), 0u)
#define Clock_UART_SetDivider(clkDivider)           Clock_UART_SetDividerRegister((clkDivider), 1u)
#define Clock_UART_SetDividerValue(clkDivider)      Clock_UART_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/

#define Clock_UART_DIV_REG    (*(reg32 *)Clock_UART__REGISTER)
#define Clock_UART_ENABLE_REG Clock_UART_DIV_REG

#endif /* !defined(CY_CLOCK_Clock_UART_H) */

/* [] END OF FILE */
