/*******************************************************************************
* File Name: LED_Green.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_LED_Green_H) /* Pins LED_Green_H */
#define CY_PINS_LED_Green_H

#include "cytypes.h"
#include "cyfitter.h"
#include "LED_Green_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    LED_Green_Write(uint8 value) ;
void    LED_Green_SetDriveMode(uint8 mode) ;
uint8   LED_Green_ReadDataReg(void) ;
uint8   LED_Green_Read(void) ;
uint8   LED_Green_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define LED_Green_DRIVE_MODE_BITS        (3)
#define LED_Green_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - LED_Green_DRIVE_MODE_BITS))
#define LED_Green_DRIVE_MODE_SHIFT       (0x00u)
#define LED_Green_DRIVE_MODE_MASK        (0x07u << LED_Green_DRIVE_MODE_SHIFT)

#define LED_Green_DM_ALG_HIZ         (0x00u << LED_Green_DRIVE_MODE_SHIFT)
#define LED_Green_DM_DIG_HIZ         (0x01u << LED_Green_DRIVE_MODE_SHIFT)
#define LED_Green_DM_RES_UP          (0x02u << LED_Green_DRIVE_MODE_SHIFT)
#define LED_Green_DM_RES_DWN         (0x03u << LED_Green_DRIVE_MODE_SHIFT)
#define LED_Green_DM_OD_LO           (0x04u << LED_Green_DRIVE_MODE_SHIFT)
#define LED_Green_DM_OD_HI           (0x05u << LED_Green_DRIVE_MODE_SHIFT)
#define LED_Green_DM_STRONG          (0x06u << LED_Green_DRIVE_MODE_SHIFT)
#define LED_Green_DM_RES_UPDWN       (0x07u << LED_Green_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define LED_Green_MASK               LED_Green__MASK
#define LED_Green_SHIFT              LED_Green__SHIFT
#define LED_Green_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define LED_Green_PS                     (* (reg32 *) LED_Green__PS)
/* Port Configuration */
#define LED_Green_PC                     (* (reg32 *) LED_Green__PC)
/* Data Register */
#define LED_Green_DR                     (* (reg32 *) LED_Green__DR)
/* Input Buffer Disable Override */
#define LED_Green_INP_DIS                (* (reg32 *) LED_Green__PC2)


#if defined(LED_Green__INTSTAT)  /* Interrupt Registers */

    #define LED_Green_INTSTAT                (* (reg32 *) LED_Green__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins LED_Green_H */


/* [] END OF FILE */
