/*******************************************************************************
* File Name: P3_0_DIN.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_P3_0_DIN_H) /* Pins P3_0_DIN_H */
#define CY_PINS_P3_0_DIN_H

#include "cytypes.h"
#include "cyfitter.h"
#include "P3_0_DIN_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    P3_0_DIN_Write(uint8 value) ;
void    P3_0_DIN_SetDriveMode(uint8 mode) ;
uint8   P3_0_DIN_ReadDataReg(void) ;
uint8   P3_0_DIN_Read(void) ;
uint8   P3_0_DIN_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define P3_0_DIN_DRIVE_MODE_BITS        (3)
#define P3_0_DIN_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - P3_0_DIN_DRIVE_MODE_BITS))
#define P3_0_DIN_DRIVE_MODE_SHIFT       (0x00u)
#define P3_0_DIN_DRIVE_MODE_MASK        (0x07u << P3_0_DIN_DRIVE_MODE_SHIFT)

#define P3_0_DIN_DM_ALG_HIZ         (0x00u << P3_0_DIN_DRIVE_MODE_SHIFT)
#define P3_0_DIN_DM_DIG_HIZ         (0x01u << P3_0_DIN_DRIVE_MODE_SHIFT)
#define P3_0_DIN_DM_RES_UP          (0x02u << P3_0_DIN_DRIVE_MODE_SHIFT)
#define P3_0_DIN_DM_RES_DWN         (0x03u << P3_0_DIN_DRIVE_MODE_SHIFT)
#define P3_0_DIN_DM_OD_LO           (0x04u << P3_0_DIN_DRIVE_MODE_SHIFT)
#define P3_0_DIN_DM_OD_HI           (0x05u << P3_0_DIN_DRIVE_MODE_SHIFT)
#define P3_0_DIN_DM_STRONG          (0x06u << P3_0_DIN_DRIVE_MODE_SHIFT)
#define P3_0_DIN_DM_RES_UPDWN       (0x07u << P3_0_DIN_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define P3_0_DIN_MASK               P3_0_DIN__MASK
#define P3_0_DIN_SHIFT              P3_0_DIN__SHIFT
#define P3_0_DIN_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define P3_0_DIN_PS                     (* (reg32 *) P3_0_DIN__PS)
/* Port Configuration */
#define P3_0_DIN_PC                     (* (reg32 *) P3_0_DIN__PC)
/* Data Register */
#define P3_0_DIN_DR                     (* (reg32 *) P3_0_DIN__DR)
/* Input Buffer Disable Override */
#define P3_0_DIN_INP_DIS                (* (reg32 *) P3_0_DIN__PC2)


#if defined(P3_0_DIN__INTSTAT)  /* Interrupt Registers */

    #define P3_0_DIN_INTSTAT                (* (reg32 *) P3_0_DIN__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins P3_0_DIN_H */


/* [] END OF FILE */
