/*******************************************************************************
* File Name: Vdd.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Vdd_H) /* Pins Vdd_H */
#define CY_PINS_Vdd_H

#include "cytypes.h"
#include "cyfitter.h"
#include "Vdd_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Vdd_Write(uint8 value) ;
void    Vdd_SetDriveMode(uint8 mode) ;
uint8   Vdd_ReadDataReg(void) ;
uint8   Vdd_Read(void) ;
uint8   Vdd_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Vdd_DRIVE_MODE_BITS        (3)
#define Vdd_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - Vdd_DRIVE_MODE_BITS))
#define Vdd_DRIVE_MODE_SHIFT       (0x00u)
#define Vdd_DRIVE_MODE_MASK        (0x07u << Vdd_DRIVE_MODE_SHIFT)

#define Vdd_DM_ALG_HIZ         (0x00u << Vdd_DRIVE_MODE_SHIFT)
#define Vdd_DM_DIG_HIZ         (0x01u << Vdd_DRIVE_MODE_SHIFT)
#define Vdd_DM_RES_UP          (0x02u << Vdd_DRIVE_MODE_SHIFT)
#define Vdd_DM_RES_DWN         (0x03u << Vdd_DRIVE_MODE_SHIFT)
#define Vdd_DM_OD_LO           (0x04u << Vdd_DRIVE_MODE_SHIFT)
#define Vdd_DM_OD_HI           (0x05u << Vdd_DRIVE_MODE_SHIFT)
#define Vdd_DM_STRONG          (0x06u << Vdd_DRIVE_MODE_SHIFT)
#define Vdd_DM_RES_UPDWN       (0x07u << Vdd_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define Vdd_MASK               Vdd__MASK
#define Vdd_SHIFT              Vdd__SHIFT
#define Vdd_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Vdd_PS                     (* (reg32 *) Vdd__PS)
/* Port Configuration */
#define Vdd_PC                     (* (reg32 *) Vdd__PC)
/* Data Register */
#define Vdd_DR                     (* (reg32 *) Vdd__DR)
/* Input Buffer Disable Override */
#define Vdd_INP_DIS                (* (reg32 *) Vdd__PC2)


#if defined(Vdd__INTSTAT)  /* Interrupt Registers */

    #define Vdd_INTSTAT                (* (reg32 *) Vdd__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins Vdd_H */


/* [] END OF FILE */
