/*******************************************************************************
* File Name: Vss.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Vss_H) /* Pins Vss_H */
#define CY_PINS_Vss_H

#include "cytypes.h"
#include "cyfitter.h"
#include "Vss_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Vss_Write(uint8 value) ;
void    Vss_SetDriveMode(uint8 mode) ;
uint8   Vss_ReadDataReg(void) ;
uint8   Vss_Read(void) ;
uint8   Vss_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Vss_DRIVE_MODE_BITS        (3)
#define Vss_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - Vss_DRIVE_MODE_BITS))
#define Vss_DRIVE_MODE_SHIFT       (0x00u)
#define Vss_DRIVE_MODE_MASK        (0x07u << Vss_DRIVE_MODE_SHIFT)

#define Vss_DM_ALG_HIZ         (0x00u << Vss_DRIVE_MODE_SHIFT)
#define Vss_DM_DIG_HIZ         (0x01u << Vss_DRIVE_MODE_SHIFT)
#define Vss_DM_RES_UP          (0x02u << Vss_DRIVE_MODE_SHIFT)
#define Vss_DM_RES_DWN         (0x03u << Vss_DRIVE_MODE_SHIFT)
#define Vss_DM_OD_LO           (0x04u << Vss_DRIVE_MODE_SHIFT)
#define Vss_DM_OD_HI           (0x05u << Vss_DRIVE_MODE_SHIFT)
#define Vss_DM_STRONG          (0x06u << Vss_DRIVE_MODE_SHIFT)
#define Vss_DM_RES_UPDWN       (0x07u << Vss_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define Vss_MASK               Vss__MASK
#define Vss_SHIFT              Vss__SHIFT
#define Vss_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Vss_PS                     (* (reg32 *) Vss__PS)
/* Port Configuration */
#define Vss_PC                     (* (reg32 *) Vss__PC)
/* Data Register */
#define Vss_DR                     (* (reg32 *) Vss__DR)
/* Input Buffer Disable Override */
#define Vss_INP_DIS                (* (reg32 *) Vss__PC2)


#if defined(Vss__INTSTAT)  /* Interrupt Registers */

    #define Vss_INTSTAT                (* (reg32 *) Vss__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins Vss_H */


/* [] END OF FILE */
