/*******************************************************************************
* File Name: DIN.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_DIN_H) /* Pins DIN_H */
#define CY_PINS_DIN_H

#include "cytypes.h"
#include "cyfitter.h"
#include "DIN_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    DIN_Write(uint8 value) ;
void    DIN_SetDriveMode(uint8 mode) ;
uint8   DIN_ReadDataReg(void) ;
uint8   DIN_Read(void) ;
uint8   DIN_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define DIN_DRIVE_MODE_BITS        (3)
#define DIN_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - DIN_DRIVE_MODE_BITS))
#define DIN_DRIVE_MODE_SHIFT       (0x00u)
#define DIN_DRIVE_MODE_MASK        (0x07u << DIN_DRIVE_MODE_SHIFT)

#define DIN_DM_ALG_HIZ         (0x00u << DIN_DRIVE_MODE_SHIFT)
#define DIN_DM_DIG_HIZ         (0x01u << DIN_DRIVE_MODE_SHIFT)
#define DIN_DM_RES_UP          (0x02u << DIN_DRIVE_MODE_SHIFT)
#define DIN_DM_RES_DWN         (0x03u << DIN_DRIVE_MODE_SHIFT)
#define DIN_DM_OD_LO           (0x04u << DIN_DRIVE_MODE_SHIFT)
#define DIN_DM_OD_HI           (0x05u << DIN_DRIVE_MODE_SHIFT)
#define DIN_DM_STRONG          (0x06u << DIN_DRIVE_MODE_SHIFT)
#define DIN_DM_RES_UPDWN       (0x07u << DIN_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define DIN_MASK               DIN__MASK
#define DIN_SHIFT              DIN__SHIFT
#define DIN_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define DIN_PS                     (* (reg32 *) DIN__PS)
/* Port Configuration */
#define DIN_PC                     (* (reg32 *) DIN__PC)
/* Data Register */
#define DIN_DR                     (* (reg32 *) DIN__DR)
/* Input Buffer Disable Override */
#define DIN_INP_DIS                (* (reg32 *) DIN__PC2)


#if defined(DIN__INTSTAT)  /* Interrupt Registers */

    #define DIN_INTSTAT                (* (reg32 *) DIN__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins DIN_H */


/* [] END OF FILE */
