/*******************************************************************************
* File Name: Joystick.h  
* Version 1.90
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Joystick_H) /* Pins Joystick_H */
#define CY_PINS_Joystick_H

#include "cytypes.h"
#include "cyfitter.h"
#include "Joystick_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Joystick_Write(uint8 value) ;
void    Joystick_SetDriveMode(uint8 mode) ;
uint8   Joystick_ReadDataReg(void) ;
uint8   Joystick_Read(void) ;
uint8   Joystick_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Joystick_DRIVE_MODE_BITS        (3)
#define Joystick_DRIVE_MODE_IND_MASK    (0xFFFFFFFFu >> (32 - Joystick_DRIVE_MODE_BITS))
#define Joystick_DRIVE_MODE_SHIFT       (0x00u)
#define Joystick_DRIVE_MODE_MASK        (0x07u << Joystick_DRIVE_MODE_SHIFT)

#define Joystick_DM_ALG_HIZ         (0x00u << Joystick_DRIVE_MODE_SHIFT)
#define Joystick_DM_DIG_HIZ         (0x01u << Joystick_DRIVE_MODE_SHIFT)
#define Joystick_DM_RES_UP          (0x02u << Joystick_DRIVE_MODE_SHIFT)
#define Joystick_DM_RES_DWN         (0x03u << Joystick_DRIVE_MODE_SHIFT)
#define Joystick_DM_OD_LO           (0x04u << Joystick_DRIVE_MODE_SHIFT)
#define Joystick_DM_OD_HI           (0x05u << Joystick_DRIVE_MODE_SHIFT)
#define Joystick_DM_STRONG          (0x06u << Joystick_DRIVE_MODE_SHIFT)
#define Joystick_DM_RES_UPDWN       (0x07u << Joystick_DRIVE_MODE_SHIFT)

/* Digital Port Constants */
#define Joystick_MASK               Joystick__MASK
#define Joystick_SHIFT              Joystick__SHIFT
#define Joystick_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Joystick_PS                     (* (reg32 *) Joystick__PS)
/* Port Configuration */
#define Joystick_PC                     (* (reg32 *) Joystick__PC)
/* Data Register */
#define Joystick_DR                     (* (reg32 *) Joystick__DR)
/* Input Buffer Disable Override */
#define Joystick_INP_DIS                (* (reg32 *) Joystick__PC2)


#if defined(Joystick__INTSTAT)  /* Interrupt Registers */

    #define Joystick_INTSTAT                (* (reg32 *) Joystick__INTSTAT)

#endif /* Interrupt Registers */

#endif /* End Pins Joystick_H */


/* [] END OF FILE */
