/* ========================================
 * Jean-Luc PADIOLLEAU
 * Lycée Vaucanson - TOURS
 * Formation PSoC 4
 * Gestion d'un Shield LCD 4884 avec Joystick
 */
 
#include <device.h>
#include <stdio.h>
#include "Display.h"
#include "Images.h"



void main()
{
	/* Initialise variables */
	uint16 Joystick;
	char Chaine[16];
	uint8 I=0;
	uint8 Mode=0;
    CyGlobalIntEnable;  /* Uncomment this line to enable global interrupts. */
	
	/* Start components */
	ADC_Start();
	ADC_StartConvert();
	LcdInit();
	LcdClear();
	LED_Red_Write(0);
	CyDelay(1000);
	LED_Red_Write(1);
	LED_Green_Write(0);
	CyDelay(1000);
	LED_Green_Write(1);
	LED_Blue_Write(0);	
	/* Display a image */
	LcdClear();
	LcdBitmap(Image[0]);
	CyDelay(2000);
	LcdClear();
	LcdString(" Images BMP ");
	LcdGotoXY(0,1);
	LcdString(" Formation  ");
	LcdGotoXY(0,2);
	LcdString("   PSoC4    ");
	LcdGotoXY(0,3);
	LcdString(" 2013/2014  ");
	CyDelay(5000);
	LcdClear();
	for(;;)
    {
		
		Joystick=ADC_GetResult16(0);
		if (Joystick < 300) Mode=1;
		else if (Joystick < 500) Mode = 0;
		else if (Joystick < 1000) Mode = 4;
		else if (Joystick < 1500) Mode = 2;
		else if (Joystick < 2100) Mode = 3;
		switch (Mode)
		{
			case 1 : Mode=0;
			case 3 : if (I>0) I--; else I=3; break;
			case 2 : Mode=0;
			case 4 : if (I<3) I++; else I=0; break;
		}
		LcdBitmap(Image[I]);
		CyDelay(1000);
	}
}



/* [] END OF FILE */
